#include <qpoint.h>
#include <qmessagebox.h>
#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include "mydialog.h"

MyDialog::MyDialog(QWidget *parent, const char* name,bool modal,WFlags f)
  : QDialog( parent, name, modal, f )
{
 pt = new QPoint(120,150);
 setMinimumSize(330,200);
 setMaximumSize(330,200);
 move(*pt);
 
 //buttons
 apply = new QPushButton(this);
 apply->setText("&OK");
 apply->resize(60,30);
 pt->setX(this->width()-160);
 pt->setY(160);
 apply->move(*pt);
 connect(apply,SIGNAL(clicked()),this,SLOT(applySlot()));

 cancel = new QPushButton(this);
 cancel->setText("&Cancel");
 cancel->resize(60,30);
 pt->setX(this->width()-90);
 pt->setY(160);
 cancel->move(*pt);
 connect(cancel,SIGNAL(clicked()),this,SLOT(cancelSlot()));
 
 //GroupBox
 myGroup = new QGroupBox(this);
 myGroup->setAlignment(AlignLeft);
 myGroup->setGeometry(5,10,width()-10,height()-55);
 
 //labels
 NameLabel = new QLabel(myGroup);
 NameLabel->setGeometry(15,20,140,20);
 NameLabel->setText("Name of product");
 
 DateLabel = new QLabel(myGroup);
 DateLabel->setGeometry(15,50,140,20);
 DateLabel->setText("Date income");

 AmountLabel = new QLabel(myGroup);
 AmountLabel->setGeometry(15,80,140,20);
 AmountLabel->setText("Amount");
 
 PriceLabel = new QLabel(myGroup);
 PriceLabel->setGeometry(15,110,140,20);
 PriceLabel->setText("Price");
 
//lineedits
 NameEdit = new QLineEdit(myGroup);
 NameEdit->setGeometry(120,20,190,20);
 NameEdit->setMaxLength(25);
 
 DateEdit = new QLineEdit(myGroup);
 DateEdit->setGeometry(120,50,190,20);
 DateEdit->setMaxLength(10);
 
 AmountEdit = new QLineEdit(myGroup);
 AmountEdit->setGeometry(120,80,190,20);
 AmountEdit->setMaxLength(10);
 
 PriceEdit = new QLineEdit(myGroup);
 PriceEdit->setGeometry(120,110,190,20);
 PriceEdit->setMaxLength(10); 
 //result of the exec()
 done(0);
}


void MyDialog::cancelSlot()
{
 setResult(CANCEL_BUTTON);
 done(CANCEL_BUTTON);
}

void MyDialog::applySlot()
{
//check
 if (strlen(NameEdit->text())==0||
     strlen(DateEdit->text())==0||
     strlen(AmountEdit->text())==0||
     strlen(PriceEdit->text())==0)
 {
  QMessageBox::warning(this,"Warning","Please, fill all the fields!","&Ok","","",QMessageBox::Default,0);
  return;
 }; 

 QString str;
 bool ok;
 char date[10];
 double db;
 long num;
 
 str=DateEdit->text();
 strcpy(date, str.ascii());
/* 
 if ( !isDate(date) )
 {
  QMessageBox::warning(this,"Warning","Date was entered with error!","&Ok","","",QMessageBox::Default,2);
  return;
 };
  */
 str=AmountEdit->text();
 num = str.toInt(&ok);
 if (!ok || num<=0)
 {
  QMessageBox::warning(this,"Warning","Amount was entered with error!","&Ok","","",QMessageBox::Default,2);
  return;
 };

 str=PriceEdit->text();
 db = str.toDouble(&ok);
 if (!ok || db<0.0000)
 {
  QMessageBox::warning(this,"Warning","Price was entered with error!","&Ok","","",QMessageBox::Default,2);
  return;
 };
 setResult(OK_BUTTON);
 done(OK_BUTTON);
}

int MyDialog::isDate(char date[10])
{
  unsigned int i;
  int day,month,year;
  for(i=0;i<strlen(date);i++)
   if(date[i]!='/') {
    if('0'>date[i] || date[i]>'9')
      return 0;
   }
  day=0;
  i=0;
  while(i<strlen(date) && '0'<=date[i] && date[i]<='9' ) {
    day*=10;
    day+=(date[i]-'0');
    i++;
  }
  if('0'<=date[i] && date[i]<='9') i++;
  else return 0;
  month=0;
  while(i<strlen(date) && '0'<=date[i] && date[i]<='9' ) {
    month*=10;
    month+=(date[i]-'0');
    i++;
  }
  if('0'<=date[i] && date[i]<='9') i++;
  else return 0;
  year=0;
  while(i<strlen(date) && '0'<=date[i] && date[i]<='9' ) {
    year*=10;
    year+=(date[i]-'0');
    i++;
  }
  printf("%d %d %d\n", day, month, year);
  if(0<=day || day>31 || month<=0 || month>12 || year<=1900 || year >= 2030) return 0;
  return 1;
}





