#include "mywidget.h"
#include "mydialog.h"
#include "myquerydialog.h"

#include <sys/types.h>
#include <unistd.h>
#include <stdio.h>
#include <stdlib.h>
#include <wait.h>

#include <qimage.h>
#include <qpixmap.h>
#include <qtoolbar.h>
#include <qtoolbutton.h>
#include <qpopupmenu.h>
#include <qmenubar.h>
#include <qtextedit.h>
#include <qfile.h>
#include <qfiledialog.h>
#include <qstatusbar.h>
#include <qmessagebox.h>
#include <qprinter.h>
#include <qapplication.h>
#include <qaccel.h>
#include <qtextstream.h>
#include <qpainter.h>
#include <qpaintdevicemetrics.h>
#include <qwhatsthis.h>
#include <qaction.h>
#include <qpoint.h>
#include <qpixmap.h>
#include <qpainter.h>
#include <qlistview.h>
#include <qdialog.h>


extern MyClass *myclass, *myclass2;
extern MyWidget *mw;
extern int pid1, pid2;
extern void f1(int);
void f2(int);
struct Product prodw;


const int ColName=0; 
const int ColDate=1;
const int ColAmount=2;	 
const int ColPrice=3;

MyWidget::MyWidget()
    : QMainWindow( 0, "main window ", WDestructiveClose )
{
   //main widget
   setMinimumSize(450,400);
   setFixedSize(450,400);
   pt = new QPoint(30,20);
   move(*pt);
   statusBar()->setSizeGripEnabled(FALSE);
   statusBar()->message("Ready",2000);

 
   QPopupMenu * exit = new QPopupMenu(this);
   menuBar()->insertItem("&File",exit);
   exit->insertItem("E&xit",qApp,SLOT(quit()),ALT+Key_X);
   
   
   QPopupMenu * edit = new QPopupMenu(this);
   menuBar()->insertItem("&Edit",edit);
   edit->insertItem("&Load",this,SLOT(loadSlot()),ALT+Key_L);
   edit->insertSeparator();   
   edit->insertItem("&Insert",this, SLOT(insSlot()),ALT+Key_I);
   edit->insertItem("&Edit",this, SLOT(editSlot()),ALT+Key_E);
   edit->insertItem("&Delete",this, SLOT(delSlot()),ALT+Key_D);
   
   QPopupMenu * query = new QPopupMenu(this);
   menuBar()->insertItem("&Query",query);
   query->insertItem("Execute &query",this, SLOT(querySlot()),ALT+Key_Q);
 
   QPopupMenu * about = new QPopupMenu(this);
   menuBar()->insertItem("&About",about);
   about->insertItem("&About program",this, SLOT(aboutSlot()),ALT+Key_A);
   
   //combobox       
   combo = new QComboBox( FALSE, this, "read-only combobox");
  
   pt->setX(20);
   pt->setY(290);
   combo->move(*pt);
   combo->resize(120,20);
   
   //label
   productlabel = new QLabel(this);
   productlabel->setGeometry(270,80,180,20);
   pt->setX(20);
   pt->setY(270);
   productlabel->move(*pt);
   productlabel->setText("Choose product for query");
   
   //buttons
   insbut = new QPushButton(this);
   pt->setX(170);
   pt->setY(290);
   insbut->move(*pt);  
   insbut->setText("&Insert");
   insbut->resize(80,30);
   connect(insbut,SIGNAL(clicked()),this,SLOT(insSlot()));

   editbut = new QPushButton(this);
   pt->setX(260);   
   pt->setY(290);
   editbut->move(*pt);  
   editbut->setText("&Edit");
   editbut->resize(80,30);
   connect(editbut,SIGNAL(clicked()),this,SLOT(editSlot()));

   delbut = new QPushButton(this);
   pt->setX(350);
   pt->setY(290);
   delbut->move(*pt);  
   delbut->setText("&Delete");
   delbut->resize(80,30);
   connect(delbut,SIGNAL(clicked()),this,SLOT(delSlot()));

   querybut = new QPushButton(this);
   pt->setX(20);
   pt->setY(340);
   querybut->move(*pt);
   querybut->setText("&Query");
   querybut->resize(120,30);
   connect(querybut,SIGNAL(clicked()),this,SLOT(querySlot()));
     
   loadbut = new QPushButton(this);
   pt->setX(170);
   pt->setY(340);
   loadbut->move(*pt);
   loadbut->setText("&Load"); 
   loadbut->resize(80,30);
   connect(loadbut,SIGNAL(clicked()),this,SLOT(loadSlot())); 
   
   aboutbut = new QPushButton(this);
   pt->setX(260);
   pt->setY(340);
   aboutbut->move(*pt);
   aboutbut->setText("&About");
   aboutbut->resize(80,30);
   connect(aboutbut,SIGNAL(clicked()),this,SLOT(aboutSlot()));
   
   exitbut = new QPushButton(this);
   pt->setX(350);
   pt->setY(340);
   exitbut->move(*pt);
   exitbut->setText("E&xit");
   exitbut->resize(80,30);
   
   connect(exitbut,SIGNAL(clicked()),this,SLOT(exitSlot()));	
   
   //listview      
   lv = new QListView(this);
   pt->setX(10);
   pt->setY(30);
   lv->move(*pt);
   lv->setCaption("vl");
   lv->resize(426,200);
   lv->addColumn("Product");
   lv->addColumn("Date");
   lv->addColumn("Amount");
   lv->addColumn("Price");
   lv->setColumnWidth(ColName,190);
   lv->setColumnWidth(ColDate,90);
   lv->setColumnWidth(ColAmount,70);
   lv->setColumnWidth(ColPrice,70);
   lv->setSorting(ColName);
   lv->setAllColumnsShowFocus(TRUE);
   
   //myclass
//   MyClass MyCls;
   
   //input form
   edit_dialog = new MyDialog(this,"Edit dialog",TRUE,WStyle_DialogBorder);
   //query form
   query_dialog = new MyQueryDialog(this,"Rezult of the query",TRUE,WStyle_DialogBorder);
 }
 
MyWidget::~MyWidget()
{
}

void MyWidget::comboItemsUpdate(QComboBox* c, QListView* l)
{
 int i=0,j=0;
 QString Name;
 bool have = FALSE;
 QListViewItemIterator it(l);
 c->clear();
 for (;it.current();++it )
 {
  Name = it.current()->text(ColName); 
  for (i=0;i<c->count();i++)
   if (Name==c->text(i))
      have=TRUE;
   else
      have=FALSE;
  if(!have)
     c->insertItem(it.current()->text(ColName),j++);
 }

}

void MyWidget::aboutSlot()
{
 QMessageBox::about( this, "Project UNIX",
 "Kurs project Unix. 4.3.3.2.\nEVM00-2 Naidan Bilegsaikhan., 2004");
}

void MyWidget::exitSlot()
{
  kill(0, SIGKILL);
  exit(0);
}


void MyWidget::loadSlot()
{
 
 if ((lv->childCount()>0)) if (QMessageBox::warning(this,
                                                "Load records",
						"All records in the table will delete and others will add! Continue?",
						"&Yes","&No","",
						QMessageBox::Yes|QMessageBox::Default,
						QMessageBox::No |QMessageBox::Escape)!=0) return;
 lv->clear(); 
 lv->insertItem(new QListViewItem(lv,"Computer","12/01/2003","17", "700"));
 lv->insertItem(new QListViewItem(lv,"Printer", "01/02/2002","24", "156"));
 lv->insertItem(new QListViewItem(lv,"Computer","18/08/2003","100","645"));
 lv->insertItem(new QListViewItem(lv,"Mouse",   "30/01/2004","19", "10"));
 lv->insertItem(new QListViewItem(lv,"Monitor", "09/11/2003","33", "190"));
 lv->insertItem(new QListViewItem(lv,"Printer", "29/01/2003","67", "240"));
 lv->setSelected(lv->firstChild(),TRUE);
 comboItemsUpdate(combo,lv);
}

void MyWidget::editSlot()
{
 if (lv->childCount()<=0) return;
 edit_dialog->setCaption("Edit record"); 
 edit_dialog->NameEdit->setText(lv->selectedItem()->text(ColName));
 edit_dialog->DateEdit->setText(lv->selectedItem()->text(ColDate));
 edit_dialog->AmountEdit->setText(lv->selectedItem()->text(ColAmount));
 edit_dialog->PriceEdit->setText(lv->selectedItem()->text(ColPrice));
 
 if (edit_dialog->exec()==OK_BUTTON)
 {
  lv->selectedItem()->setText(ColName,edit_dialog->NameEdit->text()); 
  lv->selectedItem()->setText(ColDate,edit_dialog->DateEdit->text()); 
  lv->selectedItem()->setText(ColAmount,edit_dialog->AmountEdit->text()); 
  lv->selectedItem()->setText(ColPrice,edit_dialog->PriceEdit->text()); 
  lv->triggerUpdate();
  comboItemsUpdate(combo,lv);
 }
}


void MyWidget::insSlot()
{

 edit_dialog->setCaption("Insert record");
 edit_dialog->NameEdit->setText("");
 edit_dialog->DateEdit->setText("");
 edit_dialog->AmountEdit->setText("");
 edit_dialog->PriceEdit->setText("");
 
 if(edit_dialog->exec()==OK_BUTTON)
 {
 
 if (lv->childCount()>=1000)
  {
    QMessageBox::critical(this,"Error","It is imposible to insert record because count of record can not be more then 1000!");  
    return;
  }
 
 lv->insertItem(new QListViewItem(lv,edit_dialog->NameEdit->text(),
                                     edit_dialog->DateEdit->text(),
				     edit_dialog->AmountEdit->text(),
				     edit_dialog->PriceEdit->text()));
 lv->setSelected(lv->firstChild(),TRUE);				     
 comboItemsUpdate(combo,lv);
 }
}

void MyWidget::delSlot()
{
 if (lv->childCount()<=0)
 {
  QMessageBox::critical(this,"Deleting the record","There is no items in the table!");  
  return;
 }
 if (QMessageBox::warning(this,"Deliting record",
                               "Do you really want delete this record?",
			       "&Yes","&No","",
			       QMessageBox::Yes|QMessageBox::Default,
			       QMessageBox::No|QMessageBox::Escape)!=0) return;
 delete(lv->currentItem());
 lv->triggerUpdate();
 comboItemsUpdate(combo,lv);
 lv->setSelected(lv->firstChild(),TRUE);
} 

void MyWidget::querySlot()
{
  
 if (lv->childCount()<=0) return;
 query_dialog->setCaption("Date list products '"+combo->currentText()+"'");
 QListViewItem* item;
 item = (QListViewItem*)lv->firstChild();
 int count= lv->childCount();

 QString a=combo->currentText();


 myclass->openfileforwrite();
 myclass->writetofileamount(count);

 struct String zpr;
 strcpy(zpr.str, a.ascii());
 myclass->writetofilestr(zpr);

 while(item)
 {
  strcpy(prodw.Name,  item->text(0));
  strcpy(prodw.Date, item->text(1));
  strcpy(prodw.Amount, item->text(2));
  strcpy(prodw.Price, item->text(3));
  myclass->writetofile(prodw);            // writing records
  item=(QListViewItem*)item->nextSibling();
 }


 myclass->closefile();


 kill(pid1, SIGUSR1);


}


void f2(int signum)
{
  signal(SIGUSR2, f2);

  struct String stroka;
  myclass->openfileforread(); 
  mw->query_dialog->qlv->clear();
  int amount = myclass->readfromfileamount();

  for(int i=0; i<amount; i++) {
    myclass->readfromfilestr(&stroka);
    mw->query_dialog->qlv->insertItem(new QListViewItem(mw->query_dialog->qlv, stroka.str));
  }
  myclass->closefile();

  mw->query_dialog->exec();  
}






